/* Includes ------------------------------------------------------------------*/
#include "M0_Control_Library.h"
/* Private define ------------------------------------------------------------*/

HALL_Paramter_Type       HALL_Para_M;      //HALL۲ṹ
HALL_Cal_Structure_Type  HALL_Cal_M;       //HALL۲ṹ
Observer_Status_Type HALL_Status_M;        //HALL۲״̬
_iq24 HALL_SpeedBuffer_M[HALL_SPEED_BUFFERSIZE_M];
BuffPara_Type HALL_SpeedBuffPara_M;


/*******************************************************************************
* Function Name  : HALL_Timer_Init
* Description    : ӿڶʱʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HALL_Timer_Init(void)
{
    TIM_TimeBaseInitTypeDef TIM_HALLTimeBaseInitStructure={0};  //ʹõĶʱʼýṹ
    TIM_ICInitTypeDef       TIM_HALLICInitStructure={0};        //ʹòܳʼṹ
    GPIO_InitTypeDef        GPIO_InitStructure={0};             //GPIOóʼṹ

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6| GPIO_Pin_7|GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    TIM_DeInit(TIM4);//ԶĶʱļĴиλ
    TIM_TimeBaseStructInit(&TIM_HALLTimeBaseInitStructure);//ʱʼýṹĳʼ
    TIM_HALLTimeBaseInitStructure.TIM_Period = HALL_TIMER_PERIOD;//ֵ趨
    TIM_HALLTimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;//CKDзƵ
    TIM_TimeBaseInit(TIM4,&TIM_HALLTimeBaseInitStructure);//üĴʵ

    TIM_ICStructInit(&TIM_HALLICInitStructure);//ʼýṹĳʼ
    TIM_HALLICInitStructure.TIM_Channel = TIM_Channel_1;//ͨãĬͨ1
    TIM_HALLICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;//ز
    TIM_HALLICInitStructure.TIM_ICFilter = HALL_CAP_FILTER;//ź˲
    TIM_HALLICInitStructure.TIM_ICSelection = TIM_ICSelection_TRC;//ԴΪTRC
    TIM4->CHCTLR1 |= 0x0001;//IC1ӦTI1
    TIM_ICInit(TIM4,&TIM_HALLICInitStructure);//ͨ1ãʼýṹĲͨĬ1

    //HALLöʱķƵãһ¼Ч
    TIM_PrescalerConfig(TIM4, (uint16_t)(HALL_TIMER_PRESCALAR-1), TIM_PSCReloadMode_Immediate);

    TIM_InternalClockConfig(TIM4);//رնʱĴģʽڲʱ
    TIM_SelectHallSensor(TIM4, ENABLE);//TIMx_CH1TIMx_CH2TIMx_CH3žTI1롣
    TIM_SelectInputTrigger(TIM4, TIM_TS_TI1F_ED);//ѡ˲Ķʱ1(TI1FED)ΪԴ
    TIM_SelectSlaveMode(TIM4,TIM_SlaveMode_Reset);//λģʽ C ѡеĴ(TRGI)³ʼҲһ¼Ĵźš
    TIM_UpdateRequestConfig(TIM4, TIM_UpdateSource_Regular);//Ϊ£ֻм/ŲжϻDMA

    TIM_ClearFlag(TIM4, TIM_FLAG_Update | TIM_FLAG_CC1 | TIM_FLAG_CC2 | \
                  TIM_FLAG_CC3 | TIM_FLAG_CC4 | TIM_FLAG_Trigger | TIM_FLAG_CC1OF | \
                  TIM_FLAG_CC2OF | TIM_FLAG_CC3OF | TIM_FLAG_CC4OF);//ʱжϱ־
    TIM_ITConfig(TIM4, TIM_IT_Update|TIM_IT_CC1, ENABLE);//жϣжϿ͸λ
}

/*******************************************************************************
* ROUTINE Name : HALL_Parameter_Init_M
* Description : HALLʹòʼ
* Input       : None
* Output      : None
* Return      : None
*******************************************************************************/
void HALL_Parameter_Define(Motor_Base_Type *Basestruc,HALL_Paramter_Type *HALL_Para,HALL_Cal_Structure_Type *HALL_Cal_Struc,\
                          BuffPara_Type *BuffPara,Observer_Status_Type *HALLStatus)
{

    //HALL۲
    HALL_Para->ClockFreq= HALL_TIMER_CLOCK_FREQ;
    HALL_Para->CalFreq = FREQ_SVPWM;
    HALL_Para->CalT = _IQ(1.0)/FREQ_SVPWM;
    HALL_Para->Period=HALL_TIMER_PERIOD;
    HALL_Para->Prescalar=HALL_TIMER_PRESCALAR;
    HALL_Para->Phase_Shift    =_IQ18toIQ(_IQ18div(_IQ18(HALL_PHASE_SHIFT_DEGREE),_IQ18(360)));
    HALL_Para->Degree_60_Per  =_IQ(0.166666);
    HALL_Para->Degree_120_Per =_IQ(0.333333);
    HALL_Para->Degree_180_Per =_IQ(0.5);

    //תƽʼ
    BuffPara->Length = HALL_SPEED_BUFFERSIZE_M;

    //תתǶϵʼ
    HALL_Cal_Struc->Cap_Rated = (HALL_Para->ClockFreq)/(6*Basestruc->Fn)/HALL_Para->Prescalar;
    HALL_Cal_Struc->Clbr_Step = _IQmpy(_IQ(HALL_CLBR_STEP),_IQ(0.00277778));
    HALL_Cal_Struc->Upper_Lim=HALL_MAX_SPEED_POS;
    HALL_Cal_Struc->Lower_Lim=HALL_MAX_SPEED_NEG;
    HALL_Cal_Struc->Owe_Speed=HALL_MIN_SPEED;
    HALL_Cal_Struc->Overflow_Thre=TIMER_OVERFLOW_THRE;
    HALL_Cal_Struc->Flystart_Timer_Overflow_Thre=FLYSTART_TIMER_OVERFLOW_THRE;


    //HALL۲״̬ж
    HALLStatus->OverspeedThresh = HALL_OVERSPEED_THRESH_M;
    HALLStatus->OverspeedcntThresh = HALL_OVERSPEED_CNT_THRESH_M;
    HALLStatus->UnderspeedThresh = HALL_UNDERSPEED_THRESH_M;
    HALLStatus->UnderspeedcntThresh = HALL_UNDERSPEED_CNT_THRESH_M;
    HALLStatus->VarianceThresh = HALL_SPEED_VARIANCE_THRESH_M;
    HALLStatus->UnstableCntThresh = HALL_UNSTABLE_CNT_THRESH_M;
    HALLStatus->UnstableSpeedThresh = HALL_UNSTABLE_SPEED_THRESH_M;
    HALLStatus->StallSpeedBand = HALL_STALLBAND_M;
    HALLStatus->StallSpeed = HALL_STALLSPEED_M;
    HALLStatus->StallCurr =  HALL_STALLCURR_M;
    HALLStatus->StallCntThresh = HALL_STALL_CNT_THRESH_M;
    HALLStatus->ReverseCntThresh = HALL_REVERSE_CNT_THRESH_M;
    HALLStatus->ReverseSpeedThresh = HALL_REVERSE_SPEED_THRESH_M;
    HALLStatus->HallDefaultPhasecntThresh=HALL_DEFAULT_PHASE_THRESH;

}
/*******************************************************************************
* ROUTINE Name : HALL_Status_Init_M
* Description : HALL״̬ʼ
* Input       : HALL۲ṹ  HALL۲״̬ṹ
* Output      : None
* Return      : None
*******************************************************************************/
void HALL_Status_Init_M(HALL_Cal_Structure_Type *HALLCalStruc,Observer_Status_Type *HALLStatus)
{
    TIM_Cmd(TIM4, DISABLE);//ʱʹ
    TIM_ITConfig(TIM4, TIM_IT_CC1, DISABLE);//ֹʱͨ1Ĳж

    //۲״̬ʼ
    HALLStatus->Hall_DefPhase = FALSE;
    HALLStatus->Overspeed     = FALSE;
    HALLStatus->Underspeed    = FALSE;
    HALLStatus->Reliable      = FALSE;
    HALLStatus->Timeout       = FALSE;
    HALLStatus->Stable        = TRUE;
    HALLStatus->Overspeed_CNT =0;
    HALLStatus->Underspeed_CNT= 0;
    HALLStatus->Unstable_CNT  = 0;
    HALLStatus->Hall_Default_Phase_CNT=0;

    HALLCalStruc->Hall_State_New = ((uint8_t)(GPIO_ReadInputData(GPIOB)>>6)) & HALL_GPIO_MSK;//ȡ6λȡλ;
    HALLCalStruc->Hall_State_Pre = HALLCalStruc->Hall_State_New;
    HALLCalStruc->Hall_State_BLast=HALLCalStruc->Hall_State_Pre;
    HALLCalStruc->Clbr_Target = 0;
    HALLCalStruc->Clbr_Realtime = 0;
    HALLCalStruc->Brake_Judg_stop_Flag=0;


    HALLCalStruc->Timer_Overflow_Cnt = 0;//ʱ
    HALLCalStruc->Cap_Cnt = 0;//壬Ƿǵһβ
    HALLCalStruc->Cap_Value = 0;//ֵ
    HALLCalStruc->Speed_Divider =0;//תڶתٵС

    HALLCalStruc->Angspeed_Inst= 0;//۲ٶʵʱֵֵ
    HALLCalStruc->Angspeed_Aver1 =0;//۲ٶʵʱֵֵ
    HALLCalStruc->Angspeed_Aver2 =0;//۲ٶʵʱֵֵ
    HALLCalStruc->Direction = HALL_DIRECTION_POS;//ת

    HALLCalStruc->DetectUpwindFlag=2;
    HALLCalStruc->Flystar_Timer_Overflow_Cnt=0;
    HALLAngle_Init_M(&HALL_Para_M,HALLCalStruc,HALLStatus);//ʼλǸֵ

    TIM_SetCounter(TIM4, HALL_TIMER_RESET_VALUE);//ʱĴֵ
    TIM_ITConfig(TIM4, TIM_IT_CC1, ENABLE);//ʱ1жʹ
}
/*******************************************************************************
* ROUTINE Name : HALLAngle_Init_M
* Description : ʼλȷ
* Input       : HALL۲ṹ  HALL۲״̬ṹ
* Output      : None
* Return      : None
*******************************************************************************/
void HALLAngle_Init_M(HALL_Paramter_Type *HALL_Para,HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type *Status_M)
{
#if (HALL_PLACEMENT == 120)//HALLź120ֲ
    if(Cal_M->Hall_State_New==HALL_STATE_7)
        {
            Status_M->Hall_DefPhase=TRUE;//120ֲĻ 7״̬
        }
    else
    {
        switch(Cal_M->Hall_State_New)
        {
            case HALL_STATE_5:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per/2;//30
            break;

            case HALL_STATE_1:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per + HALL_Para->Degree_60_Per/2;//90
            break;

            case HALL_STATE_3:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per + HALL_Para->Degree_60_Per/2;//150
            break;

            case HALL_STATE_2:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per -HALL_Para->Degree_60_Per/2;//210
            break;

            case HALL_STATE_6:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per - HALL_Para->Degree_60_Per/2;//270
            break;

            case HALL_STATE_4:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per/2;//330
            break;

            default:
            break;
        }
    }
#elif (HALL_PLACEMENT == 60)//HALLź60ֲ
    if((Cal_M->Hall_State_New==HALL_STATE_5)||(Cal_M->Hall_State_New==HALL_STATE_2))//15kжж 
        {
        Status_M->Hall_DefPhase=TRUE;//60ֲĻ 25״̬
        }
    else
    {
        switch(Cal_M->Hall_State_New)
        {
            case HALL_STATE_1:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per/2;//30
                break;

            case HALL_STATE_3:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per + HALL_Para->Degree_60_Per/2;//90
                break;

            case HALL_STATE_7:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per + HALL_Para->Degree_60_Per/2;//150
                break;

            case HALL_STATE_6:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per -HALL_Para->Degree_60_Per/2;//210
                break;

            case HALL_STATE_4:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per - HALL_Para->Degree_60_Per/2;//270
                break;

            case HALL_STATE_0:
                Cal_M->PosiElecPU = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per/2;//330
                break;

            default:
                break;
        }
    }
#endif
    Cal_M->PosiElecPU = Round_Circle_Limitation_PU(Cal_M->PosiElecPU);
}

/*******************************************************************************
* Function Name  : HALL_Direction_Angle_Process
* Description    : жǴ
* Input          : ״̬  ۲ṹ   ۲ṹ     ۲״̬ṹ
* Output         : none
* Return         : none.
*******************************************************************************/
void HALL_Direction_AngleCalibration(uint8_t Hall_State,HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type*Status_M,HALL_Paramter_Type *HALL_Para)
{
    _iq24 Position_Calibration ;
    Position_Calibration = Cal_M->PosiElecPU;

    Cal_M->Hall_State_New = Hall_State;

    Status_M->Timeout = FALSE;

    #if (HALL_PLACEMENT == 120)
        switch(Cal_M->Hall_State_New)
        {
            case HALL_STATE_5:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_4:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                    break;
                    case HALL_STATE_1:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                    break;
                    default:
                    break;
                }

                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift;
            break;

            case HALL_STATE_1:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_5:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                        break;
                    case HALL_STATE_3:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                        break;
                    default:
                        break;
                }
                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per;
            break;

            case HALL_STATE_3:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_1:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                        break;
                    case HALL_STATE_2:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                        break;
                    default:
                        break;
                }
                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_180_Per;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per;
            break;

            case HALL_STATE_2:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_3:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                        break;
                    case HALL_STATE_6:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                        break;
                    default:
                        break;
                }
                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_180_Per;
            break;

            case HALL_STATE_6:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_2:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                        break;
                    case HALL_STATE_4:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                        break;
                    default:
                        break;
                }
                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per;
            break;

            case HALL_STATE_4:
                switch(Cal_M->Hall_State_Pre)
                {
                    case HALL_STATE_6:
                        Cal_M->Direction = HALL_DIRECTION_POS;
                        break;
                    case HALL_STATE_5:
                        Cal_M->Direction = HALL_DIRECTION_NEG;
                        break;
                    default:
                        break;
                }
                if(Cal_M->Direction == -1)
                    Position_Calibration = HALL_Para->Phase_Shift;
                else if(Cal_M->Direction == 1)
                    Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per;
            break;

            default:
                break;
        }
    #elif (HALL_PLACEMENT == 60)
            switch(Cal_M->Hall_State_New)
            {
                case HALL_STATE_1:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_0:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                             break;
                        case HALL_STATE_3:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                             break;
                        default:
                             break;
                    }
                    if(Cal_M->Direction ==-1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per;
                    else if(Cal_M->Direction ==1)
                        Position_Calibration = HALL_Para->Phase_Shift;
                break;

                case HALL_STATE_3:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_1:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                            break;
                        case HALL_STATE_7:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                            break;
                        default:
                            break;
                    }
                    if(Cal_M->Direction == -1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per;
                    else if(Cal_M->Direction == 1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_60_Per;
                break;

                case HALL_STATE_7:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_3:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                            break;
                        case HALL_STATE_6:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                            break;
                        default:
                            break;
                    }
                    if(Cal_M->Direction == -1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_180_Per;
                    else if(Cal_M->Direction == 1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_120_Per;
                break;

                case HALL_STATE_6:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_7:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                            break;
                        case HALL_STATE_4:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                            break;
                        default:
                            break;
                    }
                    if(Cal_M->Direction == -1)
                        Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per;
                    else if(Cal_M->Direction == 1)
                        Position_Calibration = HALL_Para->Phase_Shift + HALL_Para->Degree_180_Per;
                break;

                case HALL_STATE_4:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_6:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                            break;
                        case HALL_STATE_0:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                            break;
                        default:
                            break;
                    }
                    if(Cal_M->Direction == -1)
                        Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per;
                    else if(Cal_M->Direction == 1)
                        Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_120_Per;
                break;

                case HALL_STATE_0:
                    switch(Cal_M->Hall_State_Pre)
                    {
                        case HALL_STATE_4:
                            Cal_M->Direction = HALL_DIRECTION_POS;
                            break;
                        case HALL_STATE_1:
                            Cal_M->Direction = HALL_DIRECTION_NEG;
                            break;
                        default:
                            break;
                    }
                    if(Cal_M->Direction == -1)
                        Position_Calibration = HALL_Para->Phase_Shift;
                    else if(Cal_M->Direction == 1)
                        Position_Calibration = HALL_Para->Phase_Shift - HALL_Para->Degree_60_Per;
                break;

                default:
                    break;
            }
        #endif

            Position_Calibration = Round_Circle_Limitation_PU(Position_Calibration);
      #ifdef HALL_CALI_SOFTEN
            HALL_Cali_Soften_M(Position_Calibration, Cal_M);
            #else
            Cal_M->PosiElecPU = Position_Calibration;
            #endif

            Cal_M->Hall_State_BLast = Cal_M->Hall_State_Pre;
            Cal_M->Hall_State_Pre   = Cal_M->Hall_State_New;
            Cal_M->Direction_Pre    = Cal_M->Direction;

            if ( Cal_M->Cap_Cnt < (uint16_t)65535u)
            {
                Cal_M->Cap_Cnt++;
            }
            else;
}
/*******************************************************************************
* Function Name : Hall_DefPhase_Vefify
* Description : жϻȱ
* Input  :  HALL״̬  HALL۲ṹ     HALL۲״̬ṹ    ϵͳ״̬
* Output : None
* Return : None
*******************************************************************************/
void Hall_DefPhase_Vefify(uint8_t Hall_State,HALL_Cal_Structure_Type *Cal_M, Observer_Status_Type*Status_M,System_Running_Status_Type Sys_Status)
{
   static uint8_t Possible_Defphase_Flag;
    Cal_M->Hall_State_New=Hall_State;
    if(Cal_M->Cap_Cnt>1)
    {
#if (HALL_PLACEMENT == 120)
        if(Cal_M->Hall_State_New==HALL_STATE_7)
        {
            Status_M->Hall_DefPhase=TRUE;
        }
        else
        {
            switch(Cal_M->Hall_State_Pre)
            {
                case HALL_STATE_5:
                       if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                       {
                        if((Cal_M->Hall_State_BLast!=HALL_STATE_4)\
                           ||(Cal_M->Hall_State_New!=HALL_STATE_1))
                            {
                                Possible_Defphase_Flag=1;
                            }
                        else
                            {
                                Possible_Defphase_Flag=0;
                            }

                       }
                       else
                           {
                           if((Cal_M->Hall_State_BLast!=HALL_STATE_1)\
                              ||(Cal_M->Hall_State_New!=HALL_STATE_4))
                           {
                                Possible_Defphase_Flag=1;
                           }
                           else
                                Possible_Defphase_Flag=0;
                           }
                       break;

                case HALL_STATE_1:
                      if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                      {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_5)\
                          ||(HALL_Cal_M.Hall_State_New!=HALL_STATE_3))
                           {
                               Possible_Defphase_Flag=1;
                           }
                       else
                               Possible_Defphase_Flag=0;
                      }
                      else
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_3)\
                             ||(Cal_M->Hall_State_New!=HALL_STATE_5))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                              Possible_Defphase_Flag=0;
                      }
                      break;

                case HALL_STATE_3:
                      if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_1)\
                              ||(Cal_M->Hall_State_New!=HALL_STATE_2))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                          {
                              Possible_Defphase_Flag=0;
                          }
                      }
                      else
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_2)\
                             ||(Cal_M->Hall_State_New!=HALL_STATE_1))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                          {
                              Possible_Defphase_Flag=0;
                          }
                      }
                      break;
                case HALL_STATE_2:
                      if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                      {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_3)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_6))
                          {
                              Possible_Defphase_Flag=1;
                          }
                       else
                          {
                              Possible_Defphase_Flag=0;
                          }
                      }
                      else
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_6)\
                             ||(Cal_M->Hall_State_New!=HALL_STATE_3))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                              Possible_Defphase_Flag=0;
                      }
                      break;
                case HALL_STATE_6:
                      if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                      {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_2)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_4))
                          {
                              Possible_Defphase_Flag=1;
                          }
                       else
                          {
                              Possible_Defphase_Flag=0;
                          }
                      }
                      else
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_4)\
                             ||(Cal_M->Hall_State_New!=HALL_STATE_2))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                              Possible_Defphase_Flag=0;
                      }
                      break;

                case HALL_STATE_4:
                      if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                      {
                           if((Cal_M->Hall_State_BLast!=HALL_STATE_6)\
                              ||(Cal_M->Hall_State_New!=HALL_STATE_5))
                           {
                              Possible_Defphase_Flag=1;
                           }
                       else
                           {
                              Possible_Defphase_Flag=0;
                           }
                      }
                      else
                      {
                          if((Cal_M->Hall_State_BLast!=HALL_STATE_5)\
                             ||(Cal_M->Hall_State_New!=HALL_STATE_6))
                          {
                              Possible_Defphase_Flag=1;
                          }
                          else
                          {
                              Possible_Defphase_Flag=0;
                          }
                      }
                      break;
                default:
                      break;
            }
        }
#elif (HALL_PLACEMENT == 60)
    if((HALL_Cal_M.Hall_State_New==HALL_STATE_5)||(HALL_Cal_M.Hall_State_New==HALL_STATE_2))
    {
        HALL_Status_M.Hall_DefPhase=TRUE;;
    }
   else
    {
        switch(Cal_M->Hall_State_Pre)
        {
            case HALL_STATE_1:
                   if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                   {
                    if((Cal_M->Hall_State_BLast!=HALL_STATE_0)\
                       ||(Cal_M->Hall_State_New!=HALL_STATE_3))
                        {
                            Possible_Defphase_Flag=1;
                        }
                    else
                        {
                            Possible_Defphase_Flag=0;
                        }

                   }
                   else
                       {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_3)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_0))
                       {
                            Possible_Defphase_Flag=1;
                       }
                       else
                            Possible_Defphase_Flag=0;
                       }
                   break;

            case HALL_STATE_3:
                  if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                  {
                   if((Cal_M->Hall_State_BLast!=HALL_STATE_1)\
                      ||(HALL_Cal_M.Hall_State_New!=HALL_STATE_7))
                       {
                           Possible_Defphase_Flag=1;
                       }
                   else
                           Possible_Defphase_Flag=0;
                  }
                  else
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_7)\
                         ||(Cal_M->Hall_State_New!=HALL_STATE_1))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                          Possible_Defphase_Flag=0;
                  }
                  break;

            case HALL_STATE_7:
                  if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_3)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_6))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                      {
                          Possible_Defphase_Flag=0;
                      }
                  }
                  else
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_6)\
                         ||(Cal_M->Hall_State_New!=HALL_STATE_3))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                      {
                          Possible_Defphase_Flag=0;
                      }
                  }
                  break;

            case HALL_STATE_6:
                  if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                  {
                   if((Cal_M->Hall_State_BLast!=HALL_STATE_7)\
                      ||(Cal_M->Hall_State_New!=HALL_STATE_4))
                      {
                          Possible_Defphase_Flag=1;
                      }
                   else
                      {
                          Possible_Defphase_Flag=0;
                      }
                  }
                  else
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_4)\
                         ||(Cal_M->Hall_State_New!=HALL_STATE_7))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                          Possible_Defphase_Flag=0;
                  }
                  break;

            case HALL_STATE_4:
                  if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                  {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_6)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_0))
                       {
                          Possible_Defphase_Flag=1;
                       }
                   else
                       {
                          Possible_Defphase_Flag=0;
                       }
                  }
                  else
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_0)\
                         ||(Cal_M->Hall_State_New!=HALL_STATE_6))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                      {
                          Possible_Defphase_Flag=0;
                      }
                  }
                  break;

            case HALL_STATE_0:
                  if(Cal_M->Direction_Pre==HALL_DIRECTION_POS)
                  {
                       if((Cal_M->Hall_State_BLast!=HALL_STATE_4)\
                          ||(Cal_M->Hall_State_New!=HALL_STATE_1))
                       {
                           Possible_Defphase_Flag=1;
                       }
                   else
                       {
                           Possible_Defphase_Flag=0;
                       }
                  }
                  else
                  {
                      if((Cal_M->Hall_State_BLast!=HALL_STATE_1)\
                         ||(Cal_M->Hall_State_New!=HALL_STATE_4))
                      {
                          Possible_Defphase_Flag=1;
                      }
                      else
                      {
                          Possible_Defphase_Flag=0;
                      }
                  }
                  break;

            default:
                  break;
        }
    }
#endif
        if((Possible_Defphase_Flag==1)&&(Sys_Status==RUN))
        {
            Status_M->Hall_Default_Phase_CNT++;
           if( Status_M->Hall_Default_Phase_CNT>=Status_M->HallDefaultPhasecntThresh)
           {
               Status_M->Hall_DefPhase=TRUE;
               Status_M->Hall_Default_Phase_CNT=0;
           }
        }
    }
}
/*******************************************************************************
* Function Name  : HALL_Average_Speed_Cal
* Description    : HALLתAngspeed_Aver2㣬תټжϵ
* Input          : HALL۲ṹ  HALL۲תṹ
* Output         : None
* Return         : None
*******************************************************************************/
void HALL_Average_Speed_Cal(HALL_Cal_Structure_Type *Cal_M,BuffPara_Type *SpeedBuff)
{
    Cal_M->Angspeed_Aver2 = _IQMPY_MACRO(Cal_M->Angspeed_Aver2,SpeedBuff->Inv2)\
           +_IQMPY_MACRO(Cal_M->Angspeed_Inst,SpeedBuff->Inv1);
}
/*******************************************************************************
* Function Name  : HALL_Overflow_Process
* Description    : 
* Input          : HALL۲ṹ  HALL۲״̬ṹ  HALL۲תṹ  HALLƽת
* Output         : none
* Return         : none.
*******************************************************************************/
void HALL_Overflow_Process(HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type*Status_M,_iq24 *Buffer, BuffPara_Type *BuffPara)
{
    if (Cal_M->Timer_Overflow_Cnt < (uint16_t)65535u)
        Cal_M->Timer_Overflow_Cnt++;
    if (Cal_M->Timer_Overflow_Cnt >= Cal_M->Overflow_Thre)
    {
        Status_M->Timeout = TRUE;
        Cal_M->Angspeed_Inst = 0;
        Cal_M->Angspeed_Aver1 = 0;
        Buffer_Clear(Buffer,BuffPara);
    }
}
