/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MOTOR_HALL_OBSERVER_PARAMETER_H
#define __MOTOR_HALL_OBSERVER_PARAMETER_H

/* Includes ------------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/


#define HALL_TIMER_CLOCK_FREQ       144000000uL     //HALLʹöʱʱƵ(unit-Hz)
#define HALL_TIMER_PERIOD           U16_MAX         //HALLʱֵ
#define HALL_TIMER_PRESCALAR        8               //HALLʱԤƵϵ
#define HALL_TIMER_RESET_VALUE      ((uint16_t) 0)       //HALLʱλֵ

//#define HALL_CAP_FILTER             (uint8_t) 0x0B       //HALLź˲. 11 <-> 1333 nsec
#define HALL_CAP_FILTER             (uint8_t) 0x0D       //HALLź˲. 13<->2218 nsec
//#define HALL_CAP_FILTER             (uint8_t) 0x0F       //HALLź˲. 15<->3550 nsec

//HALLװʽ
//#define HALL_PLACEMENT          120               //ǶΪ120ȷֲ
#define HALL_PLACEMENT            60                //ǶΪ60λֲ
#define HALL_GPIO_MSK           (uint8_t)0x07            //HALLźGIPOλȡֵ


#define HALL_PHASE_SHIFT_DEGREE  258                //źƫHALL-UźŵA鷴򸺴Խ(Unit_㣬0-360)

//HALL״̬
#define HALL_STATE_0 (uint8_t)0//WVU,000
#define HALL_STATE_1 (uint8_t)1//WVU,001
#define HALL_STATE_2 (uint8_t)2//WVU,010
#define HALL_STATE_3 (uint8_t)3//WVU,011
#define HALL_STATE_4 (uint8_t)4//WVU,100
#define HALL_STATE_5 (uint8_t)5//WVU,101
#define HALL_STATE_6 (uint8_t)6//WVU,110
#define HALL_STATE_7 (uint8_t)7//WVU,111


//HALL۲Ƶ(unit-Hz)
#define HALL_CAL_FREQ_M            FREQ_SVPWM
//HALL۲(unit-1s)
#define HALL_CAL_PERIOD_M          _IQ24(1.0)/HALL_CAL_FREQ_M

//HALLת޷
#define HALL_MAX_SPEED_POS          _IQ(1.5)        //HALLתֵ(Unit_per)
#define HALL_MAX_SPEED_NEG          _IQ(-1.5)       //HALLתֵ(Unit_per)
#define HALL_MIN_SPEED              _IQ(0.005)      //HALLǷֵ(Unit_per)
#define TIMER_OVERFLOW_THRE         10              //HALLʱֵ

//HALLת
#define HALL_DIRECTION_NEG   (int8_t)-1//ת
#define HALL_DIRECTION_POS   (int8_t)1//ת


#define HALL_CALI_SOFTEN              //ǶȽ
#define HALL_CLBR_STEP                 2            //ǶȲ(1.5)


//HALL۲ٶ(unit-rad/s_per)
#define HALL_OVERSPEED_THRESH_M                _IQ(1.5)
//HALL۲ٶ(unit-rad/s_per)
#define HALL_UNDERSPEED_THRESH_M                _IQ(0.05)
//HALL۲תٳжֵ
#define HALL_OVERSPEED_CNT_THRESH_M     1000
//HALL۲תٳжֵ
#define HALL_UNDERSPEED_CNT_THRESH_M    1000

//HALL۲ȱжֵ
#define HALL_DEFAULT_PHASE_THRESH       30

//HALL۲תȶжֵ(unit-rad/s_per)
#define HALL_SPEED_VARIANCE_THRESH_M     _IQ(0.125)
//HALL۲תȶжֵ
#define HALL_UNSTABLE_CNT_THRESH_M         500
//HALL۲תȶжתֵ
#define HALL_UNSTABLE_SPEED_THRESH_M       _IQ(0.02)

//HALL۲ת(unit-rad/s_per)
#define HALL_STALLBAND_M                _IQ(0.5)//0.5
//HALL۲תת(unit-rad/s_per)
#define HALL_STALLSPEED_M                _IQ(0.06)//
//HALL۲תж(unit-A_per)Ҫת޷ֵһЩ޷
#define HALL_STALLCURR_M                 _IQ(0.9)
//HALL۲תж,ʱΪתٻ
#define HALL_STALL_CNT_THRESH_M          1000

//HALL۲ⷴתж,ʱΪתٻ
#define HALL_REVERSE_CNT_THRESH_M        1000
#define HALL_REVERSE_SPEED_THRESH_M      _IQ(0.02)

//۲תƽֵ
#define HALL_SPEED_BUFFERSIZE_M          16


extern HALL_Cal_Structure_Type      HALL_Cal_M;       //HALL۲ṹ
extern HALL_Paramter_Type           HALL_Para_M;          //HALL۲ṹ
extern Observer_Status_Type         HALL_Status_M;           //HALL۲״̬
extern _iq24 HALL_SpeedBuffer_M[HALL_SPEED_BUFFERSIZE_M];
extern BuffPara_Type HALL_SpeedBuffPara_M;
/* Exported functions ------------------------------------------------------- */
//HALLöʱʼ
void HALL_Timer_Init(void);
//HALL۲
void HALL_Paramter_Cal (Motor_Base_Type *Basestruc,HALL_Paramter_Type *HALL_Para,\
                        HALL_Cal_Structure_Type *HALL_Cal_Struc,BuffPara_Type *BuffPara);
//HALLʹòʼ
void HALL_Parameter_Define(Motor_Base_Type *Basestruc,HALL_Paramter_Type *HALL_Para,HALL_Cal_Structure_Type *HALL_Cal_Struc,\
                          BuffPara_Type *BuffPara,Observer_Status_Type *HALLStatus);
//HALL״̬ʼ
void HALL_Status_Init_M(HALL_Cal_Structure_Type *HALLCalStruc,Observer_Status_Type *HALLStatus);
//HALLʼǶ
void HALLAngle_Init_M(HALL_Paramter_Type *HALL_Para,HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type *Status_M);
//жǴ
void HALL_Direction_AngleCalibration(uint8_t Hall_State,HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type*Status_M,HALL_Paramter_Type *HALL_Para);
//HALLתټͱж
void HALL_Speed_Cal(HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type*Status_M,uint32_t value);
//HALLתټ
void Hall_DefPhase_Vefify(uint8_t Hall_State,HALL_Cal_Structure_Type *Cal_M,\
                          Observer_Status_Type*Status_M ,System_Running_Status_Type Sys_Status);
//HALL
void HALL_Overflow_Process(HALL_Cal_Structure_Type *Cal_M,Observer_Status_Type*Status_M,\
                        _iq24 *Buffer, BuffPara_Type *BuffPara);
//HALL۲Ȩƽٶֵ
void HALL_Average_Speed_Cal(HALL_Cal_Structure_Type *Cal_M,BuffPara_Type *SpeedBuff);
//HALLǶȼ
void HALL_Posi_Cal_M(HALL_Cal_Structure_Type *Cal_M);
//HALL
void HALL_Cali_Soften_M(_iq24 Input, HALL_Cal_Structure_Type *Cal_M);

#endif /* __HALL_H */

