/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __MOTOR_OPERATION_AND_DISPLAY_H
#define __MOTOR_OPERATION_AND_DISPLAY_H

/* Includes -----------------------------------------------------------------*/
/* Exported types -----------------------------------------------------------*/
typedef struct{
    uint8_t lastKeyValue;
    uint8_t keyStatus;
    uint8_t unDealKey;
    uint8_t delayBit;
}t_keyPress;

typedef struct{
    uint8_t runMode;
    uint8_t ledBit1;
    uint8_t startNum;
    uint8_t halBit;
    uint8_t motorSetDir;
    uint16_t pwmDuty;
    uint16_t halTime;
    uint32_t motorSpeed;
    uint32_t aimSpeed;
    volatile uint32_t sysCounter;      //volatile
}t_sysPar;

#ifndef UINT8V
typedef unsigned char volatile  UINT8V;
#endif

/* Exported constants -------------------------------------------------------*/
#define TIMER_CLOCK_FREQ_OPERATION     144000000uL  //ʹöʱʱƵ(unit-Hz)
#define TIMER_FREQ_OPERATION           2000         //ʹöʱжƵ(unit-Hz)
#define TIMER_PRESCALER_OPERATION      17           //ʹöʱԤƵֵ:18

//ʹöʱֵ
#define TIMER_PERIDO_OPERATION_u16     ((uint16_t)(TIMER_CLOCK_FREQ_OPERATION /(uint32_t)(TIMER_FREQ_OPERATION \
                                             *(TIMER_PRESCALER_OPERATION + 1))))

#define DELAY_TIMER_NUM   4

//״̬
#define NONE_PRESS          0
#define WAITING_JITTER      1
#define WAITING_RELEASE     2

//
#define NONE_KEY			0                       //ް
#define ADD_KEY				1                       //
#define DEC_KEY				2                       //½
#define RUN_KEY				3                       //ֹͣ
#define RESET_KEY           4                       //λ

/*********************** תٲ ******************************/
#define STARTUP_SPEED           _IQ(0.3)                //ת(unit-PU)
#define STARTUP_DIRECTION        1                      //з(1ת-1ת)
#define SPEED_ADJUST_STEP       _IQ(0.1)                //ٲ(unit-PU)
#define MAX_ANGSPEED_POS_M      _IQ(0.775)              //ٶ(unit-per)
#define MAX_ANGSPEED_NEG_M      _IQ(-0.775)             //ٶ(unit-per)
#define MIN_ANGSPEED_POS_M      _IQ(0.025)              //Сٶ(unit-per)
#define MIN_ANGSPEED_NEG_M      _IQ(-0.025)             //Сٶ(unit-per)
#define SPEED_RAMP_FREQ_M        SPEED_LOOP_CAL_FREQ    //ӼٴƵ(unit-Hz)
#define ACCE_TIME_M              5                     //ʱ(unit-s)
#define DECE_TIME_M              12                     //ʱ(unit-s)

//LED˸
#define FAULT_FLICKER_TIME  (uint16_t)255                 //Ϻ˸ʱ,ʱ500us
#define OBSERVER_CONVERGE_FLICKER_TIME (uint16_t)1000     //۲ת˸ʱ,ʱ500us

#define STOP_WAITING_TIME       (uint16_t)2000   //ͣȴʱ䣬ʱ500us
/* Exported variables -------------------------------------------------------*/
extern Speed_Ramp_Control_Type SpeedRamp_M; //Ӽٿƽṹ
extern u16 ConvergeFlickCnt;                //۲ת˸ʱ
extern uint8_t  ConvergeFlickCtr;                //۲ת˸Ʊ
extern u16 DircheckwaitCnt;    //ʶʱ
extern u16 BreakwaitCnt;     //¹ȫɲʱ
/* Exported macro -----------------------------------------------------------*/

/* Exported functions ------------------------------------------------------ */
//
void Motor_Operation_Process(void);

//תٸʼ
void Speed_Initial(void);

//ָʾIO
void KEY_AND_LEDIO_Init(void);

//
void USART1_Init(uint32_t baudrate);

//ͷż
void Key_Release_Check(void);

//¼
void Key_Press_Check(void);

//Ϻ˸ƴʱ׼Ϊ500us
void LED_Flicker(uint16_t FlickInterval, uint16_t *FlickCounter,\
                GPIO_TypeDef *IOgroup, uint16_t IOpin, uint8_t *Control);

//еƵ
void Running_LED_Lighton(GPIO_TypeDef *IOgroup, uint16_t IOpin);

//еϨ
void Running_LED_Lightoff(GPIO_TypeDef *IOgroup, uint16_t IOpin);

//ʱʼ
void Timer3_Init(void);

//ȴʱ趨ʱ500us
void Time_Wait_500us(uint16_t);

//ʱʱúʱ500us
void Time_Delay_Set_500us(uint16_t Delayset, uint16_t *Delaycounter);

//ʱʱ䵽жʱ500us
Truth_Verify_Type Time_Delay_Elapse_500us(uint16_t Delaycounter);

//жʱ(0.5ms)Ϊ׼ıݼ
void Time_Delay_Process(void);

void SysDelayOvertimeDispose(void);
uint8_t SysDelayRegister(uint32_t msNum, void (*OverTimeFunc)(void));
uint8_t SysDelayUnregister(void (*OverTimeFunc)(void));

#endif
