/* Includes -----------------------------------------------------------------*/
#include "M0_type_and_Constant.h"
/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
//ұĶ
_iq Sin_Table_1024[256] = SIN_TABLE_1024;

/******************************************************************************
* Function Name  : PID_Calculaion
* Description    : ʽPID
* Input          : , , PIDṹ
* Output         : PID
* Return         : PID
******************************************************************************/
_iq24 PID_Calculaion(_iq24 hReference, _iq24 hFeedback, PID_Structure_Type *PID_Struct)
{
    _iq24 Delta_PID_Output;                     //PID

    PID_Struct->Err_New = hReference - hFeedback;//

    //PID
    Delta_PID_Output =_IQMPY_MACRO(PID_Struct->Kp,(PID_Struct->Err_New - PID_Struct->Err_Prev1))
                      +_IQMPY_MACRO(PID_Struct->Ki,PID_Struct->Err_New)
                      +_IQMPY_MACRO(PID_Struct->Kd,(PID_Struct->Err_New -\
                              2*PID_Struct->Err_Prev1 + PID_Struct->Err_Prev2));

    PID_Struct->Output_New = PID_Struct->Output_Prev + Delta_PID_Output;//PID

    //PID޷
    if(PID_Struct->Output_New > PID_Struct->Upper_Lim)
        PID_Struct->Output_New = PID_Struct->Upper_Lim;
    else if (PID_Struct->Output_New < PID_Struct->Lower_Lim)
        PID_Struct->Output_New = PID_Struct->Lower_Lim;
    else;

    //PIDֵ
    PID_Struct->Err_Prev2 = PID_Struct->Err_Prev1;
    PID_Struct->Err_Prev1 = PID_Struct->Err_New;
    PID_Struct->Output_Prev = PID_Struct->Output_New;

    return(PID_Struct->Output_New);
}

/******************************************************************************
* Function Name  : TrigonoMetric_Function
* Description    : ǶҺҼ
* Input          : Ƕ(0,1)
* Output         : ҺҼ(IQ24)
* Return         : ҺҼ.
******************************************************************************/
Struct_Cossin_Type TrigonoMetric_Function(_iq24 Angle_PU)
{
    Struct_Cossin_Type Output;
    uint16_t Angle_Num;
    uint8_t Angle_Quard;
    Angle_Num = (uint16_t)((Angle_PU>>14)&0x000003FF);
    Angle_Quard = Angle_Num/256;
    switch(Angle_Quard)
    {
        case 0:
            Output.Sin = Sin_Table_1024[Angle_Num];
            Output.Cos = Sin_Table_1024[255 - Angle_Num];
            break;
        case 1:
            Output.Sin = Sin_Table_1024[511-Angle_Num];
            Output.Cos = -Sin_Table_1024[Angle_Num-256];
            break;
        case 2:
            Output.Sin = -Sin_Table_1024[Angle_Num - 512];
            Output.Cos = -Sin_Table_1024[767-Angle_Num];
            break;
        case 3:
            Output.Sin = -Sin_Table_1024[1023 - Angle_Num];
            Output.Cos = Sin_Table_1024[Angle_Num - 768];
            break;
    }
    return(Output);
}

/******************************************************************************
* Function Name  : Clark_TransForm
* Description    : Clark任
* Input          : ྲֹϵ
* Output         : ྲֹϵ
* Return         : ྲֹϵ
******************************************************************************/
Component_2S_Type Clark_TransForm(Component_3S_Type *Input3s)
{
    Component_2S_Type  Output_Component_2S;
    Output_Component_2S.Alpha=Input3s->PhaseA;
    Output_Component_2S.Beta=_IQMPY_MACRO( (Input3s->PhaseA\
                    + Input3s->PhaseB+Input3s->PhaseB) ,DIV_SQRT3_Q24);
    return(Output_Component_2S);
}

/******************************************************************************
* Function Name  : Park_TransForm
* Description    : Park任
* Input          : ྲֹϵ,Ƕ
* Output         : תϵ
* Return         : תϵ
******************************************************************************/
Component_2R_Type Park_TransForm(Component_2S_Type *Input2s,Struct_Cossin_Type *Struct_Cossin)
{
    Component_2R_Type Output_Component_2R;
    Output_Component_2R.cd=_IQMPY_MACRO(Input2s->Alpha,Struct_Cossin->Cos)\
                            +_IQMPY_MACRO(Input2s->Beta,Struct_Cossin->Sin);
    Output_Component_2R.cq=_IQMPY_MACRO(Input2s->Beta,Struct_Cossin->Cos)\
                            -_IQMPY_MACRO(Input2s->Alpha,Struct_Cossin->Sin);
    return(Output_Component_2R);
}

/******************************************************************************
* Function Name  : Rev_Park
* Description    : park任
* Input          : תϵ, Ƕ
* Output         : ྲֹϵ
* Return         : ྲֹϵ
******************************************************************************/
Component_2S_Type Rev_Park_TransForm(Component_2R_Type *Input2r,Struct_Cossin_Type *Struct_Cossin)
{
    Component_2S_Type Output_Component_2S;
    Output_Component_2S.Alpha=_IQMPY_MACRO(Input2r->cd,Struct_Cossin->Cos)\
                                -_IQMPY_MACRO(Input2r->cq,Struct_Cossin->Sin);
    Output_Component_2S.Beta=_IQMPY_MACRO(Input2r->cd,Struct_Cossin->Sin)\
                                +_IQMPY_MACRO(Input2r->cq,Struct_Cossin->Cos);
    return(Output_Component_2S);
}
/******************************************************************************
* Function Name  : ComponentLimit_2Ror2S
* Description    : ϵ޷㣬
* Input          : ޷ǰֵ
* Output         : ޷ֵ
* Return         : ޷ֵ
/******************************************************************************/
Component_2R_Type ComponentLimit_2Ror2S(Component_2R_Type *Input,_iq24 Max,uint16_t *LimMark, _iq24 *Magtable)
{
    Component_2R_Type Output_Component_2R;
    uint16_t syntex;
    _iq24 Magnitude;
    Magnitude =_IQMPY_MACRO(Input->cd,Input->cd) + _IQMPY_MACRO(Input->cq,Input->cq);

    if(Magnitude > (Max+167772))//һ(0.01)ֹƵ
    {
       syntex = (uint16_t)(((Magnitude>>17) - (Max>>17))&0x000003FF);
       if((syntex>=1)&&(syntex<=256))//ϵƣֹ0
       {
           Output_Component_2R.cd = _IQMPY_MACRO(Input->cd, *(Magtable + syntex-1));
           Output_Component_2R.cq = _IQMPY_MACRO(Input->cq, *(Magtable + syntex-1));
       }
       *LimMark = 16384;
    }
    else
    {
       Output_Component_2R.cd = Input->cd;
       Output_Component_2R.cq = Input->cq;
       *LimMark = 0;
    }
    return(Output_Component_2R);
}

/******************************************************************************
* Function Name  : Round_Circle_Limitation
* Description    : Ƕ0-2PI֮
* Input          : Ƕ
* Output         : ƺĽǶ
* Return         : ƺĽǶ
******************************************************************************/
_iq24 Round_Circle_Limitation_Rad(_iq24 Input)
{
    _iq24 Output;
    Output = Input;
    while(Output >= PI_2_Q24)
        Output = Output - PI_2_Q24;
    while(Output < 0)
        Output = Output + PI_2_Q24;
    return(Output);
}

/******************************************************************************
* Function Name  : Round_Circle_Limitation_PU
* Description    : Ƕ0-1֮
* Input          : Ƕ
* Output         : ƽǶ
* Return         : ƽǶ.
******************************************************************************/
_iq24 Round_Circle_Limitation_PU(_iq24 Input)
{
    _iq24 Output;
    Output = Input;
    while(Output >= UNIT_Q24)
        Output = Output - UNIT_Q24;
    while(Output < 0)
        Output = Output + UNIT_Q24;
    return(Output);
}

/******************************************************************************
* Function Name  : LPF_1st_Process
* Description    : һ׵ͨ˲
* Input          : ˲˲ṹָ
* Output         : ˲ֵ
* Return         : ˲ֵ
******************************************************************************/
_iq24 LPF_1st_Process(LPF_First_Order_Type *LPF_1st, _iq24 input)
{
    LPF_1st->Out_New = _IQMPY_MACRO(LPF_1st->Input_Coef,input)+\
                       _IQMPY_MACRO(LPF_1st->Output_Coef,LPF_1st->Out_Pre);
    LPF_1st->Out_Pre =  LPF_1st->Out_New;
    return( LPF_1st->Out_New);
}

/******************************************************************************
* Function Name  : HPF_2nd_Process
* Description    : ׸ͨ˲
* Input          : ˲˲ṹָ
* Output         : ˲ֵ
* Return         : ˲ֵ
******************************************************************************/
_iq24 HPF_2nd_Process(HPF_Second_Order_Type *HPF_2nd, _iq24 input)
{
    HPF_2nd->Out_New = _IQMPY_MACRO(HPF_2nd->Input_Coef,(input - HPF_2nd->In_Pre1*2 + HPF_2nd->In_Pre2))\
                        +_IQMPY_MACRO(HPF_2nd->Output_Coef1,HPF_2nd->Out_Pre1)\
                        -_IQMPY_MACRO(HPF_2nd->Output_Coef2,HPF_2nd->Out_Pre2);

    HPF_2nd->In_Pre2 =  HPF_2nd->In_Pre1;
    HPF_2nd->In_Pre1 =  input;

    HPF_2nd->Out_Pre2 =  HPF_2nd->Out_Pre1;
    HPF_2nd->Out_Pre1 =  HPF_2nd->Out_New;
    return( HPF_2nd->Out_New);
}

/******************************************************************************
* Function Name  : BPF_2nd_Process
* Description    : ״ͨ˲
* Input          : ˲˲ṹָ
* Output         : ˲ֵ
* Return         : ˲ֵ
******************************************************************************/
_iq24 BPF_2nd_Process(BPF_Second_Order_Type *BPF_2nd,_iq24 input)
{
    BPF_2nd->Out_New = _IQMPY_MACRO(BPF_2nd->Input_Coef,(input - BPF_2nd->In_Pre1))\
                        +_IQMPY_MACRO(BPF_2nd->Output_Coef1,BPF_2nd->Out_Pre1)\
                        -_IQMPY_MACRO(BPF_2nd->Output_Coef2,BPF_2nd->Out_Pre2);

    BPF_2nd->In_Pre2 =  BPF_2nd->In_Pre1;
    BPF_2nd->In_Pre1 =  input;

    BPF_2nd->Out_Pre2 =  BPF_2nd->Out_Pre1;
    BPF_2nd->Out_Pre1 =  BPF_2nd->Out_New;
    return( BPF_2nd->Out_New);
}

/******************************************************************************
* Function Name  : Observer_Adaptor_Process
* Description    : ˲
* Input          : ˲ṹָ룬ת
* Output         : ˲
* Return         : None
******************************************************************************/
void Observer_Adaptor_Process(Observer_Adaptor_type *Adaptor,_iq24 Alpha,_iq24 Beta,_iq24 Angspeed)
{
    Adaptor->Alpha_Err = Adaptor->Alpha_Pre - Alpha;
    Adaptor->Beta_Err = Adaptor->Beta_Pre - Beta;

    Adaptor->Alpha_New = Adaptor->Alpha_Pre - _IQMPY_MACRO(_IQMPY_MACRO(Angspeed,Adaptor->Beta_Pre),\
                        Adaptor->EMF_CoefT) - _IQMPY_MACRO(Adaptor->Err_CoefT,Adaptor->Alpha_Err);
    Adaptor->Beta_New = Adaptor->Beta_Pre + _IQMPY_MACRO(_IQMPY_MACRO(Angspeed,Adaptor->Alpha_Pre),\
                        Adaptor->EMF_CoefT) - _IQMPY_MACRO(Adaptor->Err_CoefT,Adaptor->Beta_Err) ;

    Adaptor->Alpha_Pre = Adaptor->Alpha_New;
    Adaptor->Beta_Pre = Adaptor->Beta_New;
}

/******************************************************************************
* Function Name  : Speedband_Avoid
* Description    : תٸ
* Input          : תٸ롢ܴܴ
* Output         : ܺתٸ
* Return         : ܺתٸ
******************************************************************************/
_iq24 Speedband_Avoid(_iq24 Speedinput,_iq24 Band,_iq24 Bandwidth)
{
    _iq24 Speedoutput;

    if(Speedinput >= 0)
    {
        if ((Speedinput >= Band) && (Speedinput < (Band + Bandwidth)))
            Speedoutput = Band + Bandwidth;
        else if ((Speedinput < Band) && (Speedinput >= (Band - Bandwidth)))
            Speedoutput = Band - Bandwidth;
        else
            Speedoutput = Speedinput;
    }
    else
    {
        if ((Speedinput >= -Band) && (Speedinput < -(Band - Bandwidth)))
            Speedoutput = -(Band - Bandwidth);
        else if ((Speedinput < -Band) && (Speedinput >= -(Band + Bandwidth)))
            Speedoutput = -(Band + Bandwidth);
        else
            Speedoutput = Speedinput;
    }
    return(Speedoutput);
}


/******************************************************************************
* Function Name  : Dcurr_Process_Init
* Description    : ֱĴṹʼ
* Input          : ֱĴṹָ룬Ŀֵת١仯
* Output         : None
* Return         : None
******************************************************************************/
void Dcurr_Process_Init(DCurrProcess_Type * DCurrProcess, _iq24 Target, _iq24 Weakpoint, _iq24 Step)
{
    DCurrProcess->Target = Target;
    DCurrProcess->Weakpoint = Weakpoint;
    DCurrProcess->AdjustStep = Step;
}

/******************************************************************************
* Function Name  : Dcurr_Process
* Description    : ֱĴ
* Input          : ֱṹָ롢תٸֱǰֵ
* Output         : ֱߵʵʱֵ
* Return         : ֱߵʵʱֵ
******************************************************************************/
_iq24 Dcurr_Process(DCurrProcess_Type * DCurrProcess, _iq24 Speedact,_iq24 DCurrRefact)
{
    _iq24 DCurrRef;

    DCurrRef = DCurrRefact;

    //dл
    if(_IQabs(Speedact) > DCurrProcess->Weakpoint)//ͻصĳ
    {
        DCurrRef = _IQ(-0.5);
    }
    else //ջлVCƵĻָ
    {
        if( DCurrRef > DCurrProcess->Target)
            DCurrRef = DCurrRef - DCurrProcess->AdjustStep;
        else if(DCurrRef  < DCurrProcess->Target)
            DCurrRef = DCurrRef + DCurrProcess->AdjustStep;
        else
            DCurrRef  = DCurrProcess->Target;
    }
    return(DCurrRef);
}

/******************************************************************************
* Function Name  : Speed_Ramp_Process
* Description    : תб´ѭִУӼٵļƵҪжϵƵһ£
* Input          : תб½ṹָ
* Output         : б´ת
* Return         : None
******************************************************************************/
void Speed_Ramp_Process(Speed_Ramp_Control_Type *Speed_Ramp)
{
    _iq24 Speed_Ref_Output;
    Speed_Ref_Output = Speed_Ramp->Aftramp;

    //µתٺ͵ǰתٶ>=0
    if((Speed_Ref_Output >=_IQ24(0.0)) && (Speed_Ramp->Preramp >=_IQ24(0.0)))
    {
        if(Speed_Ref_Output < Speed_Ramp->Preramp)//ٴ
        {
            Speed_Ref_Output += Speed_Ramp->AccStep;
            if(Speed_Ref_Output > Speed_Ramp->Preramp)//ֵ
            {
               Speed_Ref_Output = Speed_Ramp->Preramp;
            }
            else;
        }
        else if(Speed_Ref_Output > Speed_Ramp->Preramp)//ٴ
        {
            Speed_Ref_Output -= Speed_Ramp->DecStep;
            if(Speed_Ref_Output < Speed_Ramp->Preramp)//ֵ
            {
               Speed_Ref_Output = Speed_Ramp->Preramp;
            }
            else;
        }
        else;
    }

    //µת<0,ǰת>0
    else if((Speed_Ref_Output >=_IQ24(0.0)) && (Speed_Ramp->Preramp < _IQ24(0.0)))
    {
        Speed_Ref_Output -= Speed_Ramp->DecStep;
    }

    //µתٺ͵ǰתٶ<0
    else if((Speed_Ref_Output < _IQ24(0.0)) && (Speed_Ramp->Preramp < _IQ24(0.0)))
     {
         if(Speed_Ref_Output < Speed_Ramp->Preramp)//ٴ
         {
            Speed_Ref_Output += Speed_Ramp->DecStep;
            if(Speed_Ref_Output > Speed_Ramp->Preramp)
            {
                Speed_Ref_Output = Speed_Ramp->Preramp;//ֵ
            }
            else;
         }
         else if(Speed_Ref_Output > Speed_Ramp->Preramp)//ٴ
         {
            Speed_Ref_Output -= Speed_Ramp->AccStep;
            if(Speed_Ref_Output < Speed_Ramp->Preramp)//ֵ
            {
                Speed_Ref_Output = Speed_Ramp->Preramp;
            }
            else;
         }
         else;
     }

    //µת>=0ǰת<0
    else if((Speed_Ref_Output < _IQ24(0.0)) && (Speed_Ramp->Preramp >= _IQ24(0.0)))
    {
        Speed_Ref_Output += Speed_Ramp->DecStep;
    }

    else;
    Speed_Ramp->Aftramp = Speed_Ref_Output;
}

/******************************************************************************
* Function Name : AverValue_Cal
* Description   : ƽֵ
* Input         : ʵʱֵַ
* Output        : ƽֵ
* Return        : ƽֵ
******************************************************************************/
_iq24 AverValue_Cal(_iq24 Input,_iq24 *Buffer, BuffPara_Type *Buffpara)
{
    //ֲ
    uint8_t i;
    _iq24 Sum =0;
    _iq24 Aver1 =0;
    _iq24 Aver2 =0;

    //ƽٶȼ
    for (i=0 ; i < Buffpara->Length ; i++)
    {
        Sum += *(Buffer + i);
    }
    //תٷƽתټ
    Aver1 = _IQMPY_MACRO(Sum, Buffpara->Inv1);
    Aver2 = _IQMPY_MACRO(Aver2,Buffpara->Inv2)+_IQMPY_MACRO(Input,Buffpara->Inv1);

    return(Aver1);
}


/******************************************************************************
* Function Name  : Buffer_Clear
* Description    : ʼ
* Input          : ָ룬ṹָ
* Output         : none
* Return         : none.
*******************************************************************************/
void Buffer_Clear(_iq24 *Buffer, BuffPara_Type *BuffPara)
{
    uint8_t BufferIndex;
    for(BufferIndex = 0; BufferIndex < BuffPara->Length; BufferIndex++)
    {
        *(Buffer + BufferIndex) = _IQ(0.0);
    }
    BufferIndex = 0;
    BuffPara->Index=0;
}

/******************************************************************************
* Function Name : Speed_PLL_Cal_Err
* Description   : ֪Ƕ໷
* Input         : ໷ṹָ룬ת
* Output        : ٶ
* Return        : ٶ
******************************************************************************/
_iq24 Speed_PLL_Cal(Speed_PLL_Type *SpeedPLL, _iq24 Theta_Err)
{
    //ֲ
    _iq24 Delta_PID_Output;//PID

    // ת໷PID
    SpeedPLL->Error_New = Theta_Err;
    Delta_PID_Output = _IQMPY_MACRO(SpeedPLL->Kp,(SpeedPLL->Error_New - SpeedPLL->Error_Prev))\
                       +_IQMPY_MACRO(SpeedPLL->Ki, SpeedPLL->Error_New);
    SpeedPLL->Output_New = SpeedPLL->Output_Prev + Delta_PID_Output;

    //תٳ޷
    if (_IQabs(SpeedPLL->Output_New) > SpeedPLL->Upper_Lim)
        SpeedPLL->Output_New = SpeedPLL->Output_Prev;

    //۲ֵ
    SpeedPLL->Error_Prev = SpeedPLL->Error_New;
    SpeedPLL->Output_Prev = SpeedPLL->Output_New;

    //
    return (SpeedPLL->Output_New);
}
